/*****************************************************
     ,
 (win1251),  
*****************************************************/
/*#ifndef _IO_INCLUDED_
        #include <io>
#endif*/

#include "graphlcd.h"

//     
#ifndef __ZN_GENERATOR__
    #include    "win1251_char.c"
#endif

#define _GLCD_DELAY_    (_MCU_CLOCK_FREQUENCY_ - 1e6)

//   
unsigned char column_counter;

void _glcd_delay (){
        unsigned char i;
        for (i=_GLCD_DELAY_;i>1;i--) #asm ("nop");
}

//  
void glcd_init(){
    GLCD_COM_BUS_DIR = 0x3F; //  6   
    GLCD_COM_BUS_OUT.RES = 0; //  ,    1 
    _glcd_delay();
    GLCD_COM_BUS_OUT.RES = 1; // . .  1 MIPS
    glcd_whait_busyf(1); //  BUSY 
    glcd_display_on();
}

void glcd_cls(unsigned char cry){
        unsigned int i;
        GLCD_COM_BUS_OUT.RD_WR=0; // 
        GLCD_DATA_BUS_DIR=0xFF; //   
        GLCD_COM_BUS_OUT.A0=1; // (0)/(1)
        GLCD_COM_BUS_OUT.E1=((cry & 1)==1); //  1
        GLCD_COM_BUS_OUT.E2=((cry & 2)==2); //  2

        for(i=4*64;i>0;i--)_glcd_port_write(0x0);
        glcd_set_page(4);
        GLCD_COM_BUS_OUT.A0=1; // (0)/(1)
        GLCD_COM_BUS_OUT.E1=((cry & 1)==1); //  1
        GLCD_COM_BUS_OUT.E2=((cry & 2)==2); //  2
        for(i=4*64;i>0;i--)_glcd_port_write(0x0);
        
        glcd_goto_xy(0,0);
}

void glcd_puts_text(unsigned char *addr){
        while(*addr){
                glcd_put_char(*addr);
                addr++;
        }
}

void glcd_put_char(unsigned char char_){
        unsigned char i=0;
        GLCD_COM_BUS_OUT.RD_WR=0; // 
        GLCD_DATA_BUS_DIR=0xFF; //   
        GLCD_COM_BUS_OUT.A0=1; // (0)/(1)
        for(i=0;i<5;i++){
                _glcd_port_write(char_generator[char_][i]);
                column_counter++;
                if(column_counter==64){glcd_set_adress(64);GLCD_COM_BUS_OUT.A0=1;}
                else if (column_counter>127){glcd_set_adress(0);GLCD_COM_BUS_OUT.A0=1;}
        }
        _glcd_port_write(0);
        column_counter++;
}

void glcd_set_start_line(unsigned char start_line){
        glcd_write(DISPLAY_START_LINE|start_line,0,3);
}

 /*************************************************************************
 8-    

   (x1,y1),   (x2,y2)
*************************************************************************/
void glcd_line(int x1, int y1, int x2, int y2,unsigned char color)
{
    int x;
    int y;
    int dx;
    int dy;
    int sx;
    int sy;
    int z;
    int e;
    int i;
    bit ch;

    x = x1;
    y = y1;
    dx = abs(x2-x1);
    dy = abs(y2-y1);
    sx = sign((double)(x2-x1));
    sy = sign((double)(y2-y1));
    if( dx==0&&dy==0 )
    {
        glcd_put_pixel(x1, y1, color);
        return;
    }
    if( dy>dx )
    {
        z = dx;
        dx = dy;
        dy = z;
        ch = true;
    }
    else
    {
        ch = false;
    }
    e = 2*dy-dx;
    i = 1;
    do
    {
        glcd_put_pixel(x, y, color);
        while(e>=0)
        {
            if( ch )
            {
                x += sx;
            }
            else
            {
                y += sy;
            }
            e -= 2*dx;
        }
        if( ch )
        {
            y += sy;
        }
        else
        {
            x += sx;
        }
        e += 2*dy;
        ++i;
    }
    while(i<=dx);
    glcd_put_pixel(x, y, color);
}

/*************************************************************************
    

   (xc, yc),  r.
*************************************************************************/
void glcd_circle(int xc, int yc, int r,char color)
{
    int x;
    int y;
    int d;

    x = 0;
    y = r;
    d = 3-2*r;
    while(y>=x)
    {
        glcd_put_pixel((x+xc), (y+yc), color);
        glcd_put_pixel((x+xc), (-y+yc), color);
        glcd_put_pixel((-x+xc), (y+yc), color);
        glcd_put_pixel((-x+xc), (-y+yc), color);
        glcd_put_pixel((y+xc), (x+yc), color);
        glcd_put_pixel((y+xc), (-x+yc), color);
        glcd_put_pixel((-y+xc), (x+yc), color);
        glcd_put_pixel((-y+xc), (-x+yc), color);
        
        if( d<0 )d += 4*x+6;
        else{
            d += 4*(x-y)+10;
            --y;
        }
        ++x;
    }
}

// / 
void    glcd_put_pixel(unsigned char x, unsigned char y, unsigned char color){
        unsigned char page;
        if ((y<=63)&&(x<=127)){
                page=y/8;//  
                glcd_goto_xy(x,page);
                if(color==0) glcd_read_modify_write(~(1<<(y%8)),4,x,page);
                else if(color>0) glcd_read_modify_write((1<<(y%8)),1,x,page);
        }
}


/*  ->  ->           
   :    _   
   : _ OR byte_mod
*/
void    glcd_read_modify_write(unsigned char byte_mod, unsigned char mod_type,
unsigned char x_column, unsigned char y_page){
	unsigned char read_data;

#ifdef  _GLCD_DEBUG_
      printf("Prosedure: glcd_read_modify_write(byte_mod=%i, mod_type=%i, x=%i, y=%i)\n\r",
      byte_mod, mod_type, x_column, y_page); 
#endif
	
	glcd_goto_xy(x_column, y_page);

	GLCD_DATA_BUS_DIR=0x00; //   
        GLCD_DATA_BUS_OUT=0x00; //   
	GLCD_COM_BUS_OUT.RD_WR=1; // 

#ifdef  _GLCD_DEBUG_
      printf("  GLCD_COM_BUS_OUT.RD_WR=%i\n\r",
      GLCD_COM_BUS_OUT.RD_WR); 
#endif

	GLCD_COM_BUS_OUT.A0=1;// 

	read_data=_glcd_port_read(); //   

#ifdef  _GLCD_DEBUG_
      printf("  read_data=%i\n\r",
      read_data); 
#endif

	read_data=_glcd_port_read(); //   

#ifdef  _GLCD_DEBUG_
      printf("  read_data=%i\n\r",
      read_data); 
#endif
        if(mod_type==1)read_data|=byte_mod; //  OR
        else if(mod_type==2)read_data=~read_data; //  INV
        else if(mod_type==3)read_data=~(read_data|byte_mod);//XOR
        else if(mod_type==4)read_data=(read_data&byte_mod);//AND

#ifdef  _GLCD_DEBUG_
      printf("  modified: read_data=%i\n\r",
      read_data); 
#endif
                
	glcd_set_adress(x_column);
	GLCD_COM_BUS_OUT.A0=1;// 
	_glcd_port_write(read_data); // 

#ifdef  _GLCD_DEBUG_
      printf("END Prosedure\n\r"); 
#endif
}

//	   [0-63-127][0-7]
void    glcd_goto_xy(unsigned char x, unsigned char  y){
#ifdef  _GLCD_DEBUG_
      printf("Prosedure: glcd_goto_xy(x=%i, y=%i)\n\r",x,y); 
#endif

	glcd_set_page(y);
        glcd_set_adress(x);

#ifdef  _GLCD_DEBUG_
      printf("END Prosedure\n\r\n\r"); 
#endif
}

//	  [0-7]
void    glcd_set_page(unsigned char page){
#ifdef  _GLCD_DEBUG_
      printf("Prosedure: glcd_set_page(page=%i)\n\r",page); 
#endif

	glcd_write(page|SET_PAGE, 0, 3);

#ifdef  _GLCD_DEBUG_
      printf("END Prosedure\n\r\n\r"); 
#endif
}

//	  [0-63-127]
void    glcd_set_adress(unsigned char column){
#ifdef  _GLCD_DEBUG_
      printf("Prosedure: glcd_set_adress(column=%i)\n\r",column); 
#endif
	if ((column&SET_ADRESS)!=SET_ADRESS)	glcd_write(column|SET_ADRESS, 0, 1);
	if ((column&SET_ADRESS)==SET_ADRESS)	glcd_write(column|SET_ADRESS, 0, 2);
	column_counter=column;
#ifdef  _GLCD_DEBUG_
      printf("END Prosedure\n\r\n\r"); 
#endif
}

//  
void	glcd_display_on(){
	glcd_write(DISPLAY_ON, 0, 3);
}

/*   BYSY_FLAG==1
	crystall = [1-3], 1) 	2) 
*/
void	glcd_whait_busyf(unsigned char crystall){
	unsigned char tmp;
        GLCD_DATA_BUS_DIR=0x00; //   
        GLCD_DATA_BUS_OUT=0x00; //   
        GLCD_COM_BUS_OUT.RD_WR=1; // 
	GLCD_COM_BUS_OUT.A0=0;// 
        GLCD_COM_BUS_OUT.E1=((crystall & 1)==1); //  1
        GLCD_COM_BUS_OUT.E2=((crystall & 2)==2); //  2
	while ((tmp & BUSY_F)==BUSY_F){
		tmp=_glcd_port_read();
	}
}

/*    ,   ,   -   
	crystall = [1-3], 1) 	2) 	3) 
	com_dat = [0-1]	0) 	1) 
*/
void	glcd_write(unsigned char byte, unsigned char com_dat, unsigned char crystall){
	GLCD_COM_BUS_OUT.RD_WR=0; // 
        GLCD_DATA_BUS_DIR=0xFF; //   
        GLCD_COM_BUS_OUT.A0= com_dat; // (0)/(1)
        GLCD_COM_BUS_OUT.E1= ((crystall & 1)==1); //  1
        GLCD_COM_BUS_OUT.E2= ((crystall & 2)==2); //  2
	_glcd_port_write(byte);
}

/*    ,   ,   -   
	crystall = [1-3], 1) 	2) 	3) 
	com_dat = [0-1]	0) 	1) 
*/
unsigned char	glcd_read(unsigned char com_dat, unsigned char crystall){
    GLCD_DATA_BUS_DIR=0x00; //   
    GLCD_DATA_BUS_OUT=0x00; //   
    GLCD_COM_BUS_OUT.RD_WR=1; // 
    GLCD_COM_BUS_OUT.A0= com_dat; // (0)/(1)
    GLCD_COM_BUS_OUT.E1= ((crystall & 1)==1); //  1
    GLCD_COM_BUS_OUT.E2= ((crystall & 2)==2); //  2
    return	_glcd_port_read();
}

//    ,   E
void	_glcd_port_write(unsigned char byte){
    GLCD_COM_BUS_OUT.E=1; //  1
    GLCD_DATA_BUS_OUT=byte;//    
    _glcd_delay();
    GLCD_COM_BUS_OUT.E=0; //  0
}

//    ,   E
unsigned char	_glcd_port_read(){
    unsigned char byte;
    
#ifdef  _GLCD_DEBUG_
      printf("Prosedure: _glcd_port_read()\n\r"); 
#endif

    GLCD_COM_BUS_OUT.E=1; //  1
    _glcd_delay();
    byte=GLCD_DATA_BUS_IN; //    

    GLCD_COM_BUS_OUT.E=0; //  0
    
#ifdef  _GLCD_DEBUG_
      printf("END Prosedure: return=%i\n\r\n\r",byte); 
#endif
    return byte;
}
