/*------------------------------------------------------------------------
  /   +  :
 glcd_put_pixel(); glcd_line(); glcd_circle();


 : cvavr
 : 0.3b
 : Vooon


 :
                            
1       DISPLAY_OFF             0B0011_1110
2       DISPLAY_ON              0B0011_1111
3       DISPLAY_START_LINE      0B1100_0000 OR DISPLAY_START_LINE (0...63)
4       SET_PAGE                0B1011_1000 OR PAGE (0...7)
5       SET_ADRESS              0B0100_0000 OR COLUMN_ADDRESS (0...63)

:
                                
1       BUSY_FLAG               0B1000_0000
2       ON_OFF_FLAG             0B0010_0000
3       RESET_FLAG              0B0001_0000
------------------------------------------------------------------------*/

#ifndef	__GRAPH_LCD__
	//    
	#define __GRAPH_LCD__
	//
	#define	DISPLAY_OFF             0x3E  //  0011 1110
	#define	DISPLAY_ON              0x3F  //  0011 1111
	#define	DISPLAY_START_LINE      0xC0  //  1100 0000
	#define	SET_PAGE                0xB8  //  1011 1000
	#define	SET_ADRESS              0x40  //  0100 0000
	//
	#define	BUSY_F                  0x80  //  1000 0000
	#define	ON_OFF_F                0x20  //  0010 0000
	#define	RESET_F                 0x10  //  0001 0000

//   
#ifndef __GLCD_DATA_BUS__
    #define __GLCD_DATA_BUS__
    #define GLCD_DATA_BUS_IN             PINB
    #define GLCD_DATA_BUS_OUT            PORTB
    #define GLCD_DATA_BUS_DIR            DDRB
#endif

//   
#ifndef __GLCD_COM_BUS__
    #define __GLCD_COM_BUS__
    #define GLCD_COM_BUS_OUT             PORTA
    #define GLCD_COM_BUS_DIR             DDRA
#endif

//  :
#ifndef A0
    #define A0              0
#endif
#ifndef RD_WR
    #define RD_WR           1
#endif
#ifndef E
    #define E               2
#endif
#ifndef E1
    #define E1              3
#endif
#ifndef E2
    #define E2              4
#endif
#ifndef RES
    #define RES             5
#endif

//Prototypes
#pragma used+


/****************************************************
     Bresenham Algorythm implementation
     
 (   ,    
  )
****************************************************/
#define __BREZENHARM_ALGORITHM__
#ifndef _MATH_INCLUDED_
        #include <math.h>
#endif
#define true    1
#define false   0
//  
void glcd_line(int x1, int y1, int x2, int y2,unsigned char color);
//  
void glcd_circle(int xc, int yc, int r,char color);
/***************************************************/

//   (    )
void glcd_puts_text(unsigned char *addr);
//      ( 5x8)
void glcd_put_char(unsigned char char_);
//  (   0)
void glcd_cls(unsigned char cry);
//     [0-63]
void glcd_set_start_line(unsigned char start_line);
//	  [0-63-127]
void    glcd_set_adress(unsigned char column);
//	  [0-7]
void    glcd_set_page(unsigned char page);
//	   [0-63-127][0-7]
void    glcd_goto_xy(unsigned char x, unsigned char  y);
// /  (color =0 - ; >0 - )
void    glcd_put_pixel(unsigned char x, unsigned char y, unsigned char color);
//  ->  -> 
// mod_type:
#define GLCD_OR         1
#define GLCD_INV        2
#define GLCD_XOR        3
#define GLCD_AND        4
void    glcd_read_modify_write(unsigned char byte_mod, unsigned char mod_type,
unsigned char x_column, unsigned char y_page);
//
void	glcd_init();
//  
void	glcd_display_on();
//   
void	glcd_whait_busyf(unsigned char crystall);
// ,  
void	glcd_write(unsigned char byte, unsigned char com_dat, unsigned char crystall);
// ,  
unsigned char	glcd_read(unsigned char com_dat, unsigned char crystall);
//    ,   E
void	_glcd_port_write(unsigned char byte);
//    ,   E
unsigned char	_glcd_port_read();
// 
void _glcd_delay ();


#pragma used-
// graphlcd.c  .lib , : #pragma library graphlcd.lib,   cvavr\inc\
//#pragma library graphlcd.lib
#endif
